#ifndef LIB_ERROR_FUNCTIONS_IMPORT_MQH_INCLUDED
#define LIB_ERROR_FUNCTIONS_IMPORT_MQH_INCLUDED
#property version "4.2";
/**********************************************************************************
 * Copyright (C) 2010-2022 Dominik Egert <info@freie-netze.de>
 *
 * This file is error code resolver import functions include file.
 *
 * MQLplus, including this file may not be copied and/or distributed 
 * without explecit permit by the author.
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4.2
 *  State: public
 *
 *  File information
 *  ================
 *
 *
 *
 *
 *
 *
 *
*/
#ifdef DBG_MSG_TRACE_FILE_LOADER
    DBG_MSG_TRACE_FILE_LOADER

#endif



//*********************************************************************************************************************************************************/
// Global error handler import declaration
//
#ifdef __MQL4_COMPATIBILITY_CODE__
    #ifndef LIB_ERROR_STANDALONE_COMPILE
    	#import "LibMQLplus/MQLplus.ex4"

    #else
    	#import "LibError/LibError.ex4"

    #endif

#else
    #ifndef LIB_ERROR_STANDALONE_COMPILE
    	#import "LibMQLplus/MQLplus.ex5"
        
    #else
    	#import "LibError/LibError.ex5"

    #endif

#endif


    /////////////////////////////////////////////////////////////////////
    //
    //  Library imports
    //

        void            LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, SetMqlErrorCode)(               const uint          err_code,
                                                                                                    const string        comment = "",
                                                                                                    const string        comment1 = "",
                                                                                                    const string        comment2 = "",
                                                                                                    const string        comment3 = "",
                                                                                                    const string        comment4 = "",
                                                                                                    const string        comment5 = "",
                                                                                                    const string        comment6 = "",
                                                                                                    const string        comment7 = "",
                                                                                                    const string        comment8 = "",
                                                                                                    const string        comment9 = "",
                                                                                                    const string        commentA = "",
                                                                                                    const string        commentB = "",
                                                                                                    const string        commentC = "",
                                                                                                    const string        commentD = "",
                                                                                                    const string        commentE = "",
                                                                                                    const string        commentF = "");

        const bool      LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, SetUserErrorCode)(              const uint          err_code,
                                                                                                    const string        comment = "",
                                                                                                    const string        comment1 = "",
                                                                                                    const string        comment2 = "",
                                                                                                    const string        comment3 = "",
                                                                                                    const string        comment4 = "",
                                                                                                    const string        comment5 = "",
                                                                                                    const string        comment6 = "",
                                                                                                    const string        comment7 = "",
                                                                                                    const string        comment8 = "",
                                                                                                    const string        comment9 = "",
                                                                                                    const string        commentA = "",
                                                                                                    const string        commentB = "",
                                                                                                    const string        commentC = "",
                                                                                                    const string        commentD = "",
                                                                                                    const string        commentE = "",
                                                                                                    const string        commentF = "");

        const bool      LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResetUserErrorCode)(            const int           if_err_no_is);
        void            LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResetUserErrorCode)();

        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)();
        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          int&                error_code);
        const int       LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          string&             error_msg);
        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          const ulong         error_code,
                                                                                                    const string        prefix);
        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          const long          error_code,
                                                                                                    const string        prefix);
        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          const uint          error_code,
                                                                                                    const string        prefix);
        const string    LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, ResolveLastErrorCode)(          const int           error_code,
                                                                                                    const string        prefix);

        const int       LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, GetLastErrorCode)();
        const int       LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, GetLastResolvedErrorCode)();

        const bool      LIB_NAMESPACE_DEF(LIB_ERROR_LIBRARY_PREFIX, RegisterErrorCodeResolver)(     const ushort        group_id,
                                                                                                    const TUsrErrFunc   resolver_func_ptr);


    //
    /////////////////////////////////////////////////////////////////////


#import
//
// END Global error handler import declaration
//*********************************************************************************************************************************************************/
#endif // LIB_ERROR_FUNCTIONS_IMPORT_MQH_INCLUDED
